#ifndef __DB_H_
#define __DB_H_

#ifdef HAVE_CONFIG_H
# include "config.h"
#endif

#include <sys/types.h>
#if HAVE_INTTYPES_H
# include <inttypes.h>
#else
# if HAVE_STDINT_H
#  include <stdint.h>
# endif
#endif
#include <limits.h>

typedef struct {
	char db_path[PATH_MAX+1];
	uint32_t db_datasize;
	uint8_t db_marks;
} DBHEAD;

typedef struct {
	int db_fd;
} DB;

DB * db_open();
int db_close();
int db_put();
int db_argput();
int db_get();
int db_readall();

#endif /* __DB_H_ */
