#ifndef __FI_H_
#define __FI_H_

#ifdef HAVE_CONFIG_H
# include "config.h"
#endif

#include <sys/types.h>
#if HAVE_INTTYPES_H
# include <inttypes.h>
#else
# if HAVE_STDINT_H
#  include <stdint.h>
# endif
#endif

#define FI_CHFISIZE 56
#define FI_CSUMSIZE 20
#define FI_STRCSUMSIZE (2*FI_CSUMSIZE)

typedef struct {
	ino_t fi_ino;
	mode_t fi_mode;
	nlink_t fi_nlink;
	uid_t fi_uid;
	gid_t fi_gid;
	time_t fi_ctime;
	off_t fi_size;
	uint32_t fi_flags;
	char fi_sha[FI_CSUMSIZE];

#define FI_MINO   0x0001
#define FI_MMODE  0x0002
#define FI_MNLINK 0x0004
#define FI_MUID   0x0008
#define FI_MGID   0x0010
#define FI_MCTIME 0x0020
#define FI_MSIZE  0x0040
#define FI_MFLAGS 0x0080
#define FI_MSHA   0x0100

#define FI_MFULL  0x01FF
#define FI_MCHANGE (FI_MINO|FI_MMODE|FI_MNLINK|FI_MUID|FI_MGID|FI_MFLAGS)	
	uint16_t fi_mask;
} FI;

void fi_pshow();
void fi_hshow();
void fi_hxshow();

void fi_stoch();
void fi_chtos();

#endif /* __FI_H_ */
